char fileRoot[] = "";
char fileName[] = "/S5Wave";
char fileNums[] = "99999999";
char fileNumn = 1;

void dumpFilename(char *fname) {
  if (strlen(fileRoot) > 0) {
    if (!SD.exists(fileRoot))
      SD.mkdir(fileRoot);
  }
  for (; fileNumn < 1000; fileNumn++) {
    sprintf(fname, "%s%s%04d.bmp", fileRoot, fileName, fileNumn);
    if (!SD.exists(fname)) break;
  }
}

byte buff[TFT_MAX_X / 2];
int16_t bmpHeader[7 + 20 + 32] = {
  ('M' << 8 | 'B'),
  (14 + 40 + 64 + (320 * 240 / 2)), 0,  // Total file size
  0, 0,
  (14 + 40 + 64), 0,  // Total Header size

  40,  0,         // Tpe Info0 (40 byte)
  320, 0,         // Width  =  320
  -240, -1,       // Height = -240
  1,              // Plane = 1
  4,              // Bits  = 4
  0, 0,           //
  (320 * 240 / 2), 0, // Image size
  0, 0,           //
  0, 0,           //
  0, 0,           //
  0, 0,           //

  0x0000, 0x0000,  // BLACK BGRa
  0x00FF, 0x0000,  // BLUE
  0xFF00, 0x0000,  // GREEN
  0xFFFF, 0x0000,  // CYAN
  0x0000, 0x00FF,  // RED
  0x00FF, 0x00FF,  // MAGENTA
  0xFF00, 0x00FF,  // YELLOW
  0xFFFF, 0x00FF,  // WHITE
  0x9999, 0x0099,  // GRAY1
  0xAAAA, 0x00AA,  // GRAY2
  0xFF00, 0x0000,  //
  0xFF00, 0x0000,  //
  0xFF00, 0x0000,  //
  0xFF00, 0x0000,  //
  0xFF00, 0x0000,  //
  0xFF00, 0x0000   //
};

int dumpx(int out, char *fname, void (*pbar)(int)) {
  File dumpFile = SD.open(fname, FILE_WRITE);
  if (!dumpFile) return (-2);

  if (dumpFile.write((uint8_t *)bmpHeader, sizeof(bmpHeader)) != sizeof(bmpHeader)) {
    dumpFile.close();
    return (-3);
  }

  for (int y = 0; y < TFT_MAX_Y; y++) {
    for (int x = 0; x < TFT_MAX_X; x += 2) {
      buff[x / 2] = ((bmpBuff[y][x] << 4) | bmpBuff[y][x + 1]);
    }

    if (dumpFile.write((uint8_t *)buff, (320 / 2)) != (320 / 2)) {
      dumpFile.close();
      return (-4);
    }
    pbar((y * 100) / TFT_MAX_Y);
  }

  dumpFile.close();
  return (0);
}

